SystemOrganization addCategory: #'Zinc-SSO-OAuth2-Core'!

Object subclass: #ZnOAuth2ConsumerData
	instanceVariableNames: 'key secret'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-OAuth2-Core'!

!ZnOAuth2ConsumerData class methodsFor: 'instance creation' stamp: 'JanVanDeSandt 10/7/2012 16:04'!
key: aKey secret: aSecret

	^ self new setKey: aKey andSecret: aSecret! !

!ZnOAuth2ConsumerData methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:37'!
key
	^ key! !

!ZnOAuth2ConsumerData methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:37'!
secret
	^ secret! !

!ZnOAuth2ConsumerData methodsFor: 'initialize-release' stamp: 'JanVanDeSandt 10/7/2012 16:03'!
setKey: aKey andSecret: aSecret

	key := aKey.
	secret := aSecret ! !

Object subclass: #ZnOAuth2Session
	instanceVariableNames: 'consumerData redirectUri accessToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-OAuth2-Core'!

ZnOAuth2Session subclass: #ZnFacebookOAuth2Session
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-OAuth2-Core'!

!ZnFacebookOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 14:53'!
authenticationUrl

	^ (ZnUrl fromString: 'https://graph.facebook.com/oauth/authorize')
		queryAt: 'client_id' put: self consumerData key ;
		queryAt: 'redirect_uri' put: self redirectUri ;
		queryAt: 'scope' put: self scope ;
		yourself.
! !

!ZnFacebookOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 14:31'!
getUserData

	| url response |
	
	url := (ZnUrl fromString: 'https://graph.facebook.com/me')
		queryAt: 'access_token' put: self accessToken;
		yourself.

	response := ZnClient new get: url.
	
	^ NeoJSONReader fromString: response! !

!ZnFacebookOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 14:18'!
handleAuthenticationCallback: request 

	| code url oauthResponse |
	
	code := request uri queryAt: 'code' ifAbsent: [ ^nil ].

	url := (ZnUrl fromString: 'https://graph.facebook.com/oauth/access_token')
		queryAt: 'client_id' put: self consumerData key ;
		queryAt: 'redirect_uri' put: 'http://localhost:8100/sso-facebook-callback' ;
		queryAt: 'client_secret' put: self consumerData secret ;
		queryAt: 'code' put: code;
		yourself.
	
	oauthResponse := ZnClient new get: url.
	
	accessToken := (self fieldDictionaryFrom: oauthResponse) at: 'access_token'.! !

!ZnFacebookOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 14:53'!
scope

	^ 'email'! !

ZnOAuth2Session subclass: #ZnGoogleOAuth2Session
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-OAuth2-Core'!

!ZnGoogleOAuth2Session commentStamp: 'JanVanDeSandt 10/7/2012 14:56' prior: 0!
ZnGoogleOAuth2Session 

Google OAuth2 docs: https://developers.google.com/accounts/docs/OAuth2WebServer!

!ZnGoogleOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 14:57'!
authenticationUrl

	| authUrl |

	authUrl := (ZnUrl fromString: 'https://accounts.google.com/o/oauth2/auth')
		queryAt: 'response_type' put: 'code' ;
		queryAt: 'client_id' put: self consumerData key ;
		queryAt: 'redirect_uri' put: self redirectUri ;
		queryAt: 'scope' put: self scope ;
		queryAt: 'state' put: 'no-op' ;
		queryAt: 'access_type' put: 'online' ;
		yourself.
		
	^authUrl! !

!ZnGoogleOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 15:27'!
getUserData

	| url response |
	
	url := (ZnUrl fromString: 'https://www.googleapis.com/oauth2/v1/userinfo')
		queryAt: 'access_token' put: self accessToken;
		yourself.

	response := ZnClient new get: url.
	
	^ NeoJSONReader fromString: response! !

!ZnGoogleOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 15:26'!
handleAuthenticationCallback: request 

	| code tokenRequest tokenResponse tokenData |
	
	code := request uri queryAt: 'code' ifAbsent: [ ^nil ].

	tokenRequest  := (ZnRequest post: (ZnUrl fromString: 'https://accounts.google.com/o/oauth2/token'))
		entity: (ZnApplicationFormUrlEncodedEntity new
			at: 'code' put: code ;
			at: 'client_id' put: self consumerData key ;
			at: 'client_secret' put: self consumerData secret ;
			at: 'redirect_uri' put: self redirectUri ;
			at: 'grant_type' put: 'authorization_code' ;
			yourself) ;
		yourself.

	tokenResponse := ZnClient new 
		request: tokenRequest ;
		post.
	tokenData := NeoJSONReader fromString: tokenResponse.
		
	accessToken := tokenData at: 'access_token'.! !

!ZnGoogleOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 14:52'!
scope

	^ 'https://www.googleapis.com/auth/userinfo.email https://www.googleapis.com/auth/userinfo.profile'! !

!ZnOAuth2Session class methodsFor: 'instance creation' stamp: 'JanVanDeSandt 10/7/2012 14:05'!
facebook: aConsumerData

	^ ZnFacebookOAuth2Session new
		consumerData: aConsumerData ;
		yourself! !

!ZnOAuth2Session class methodsFor: 'instance creation' stamp: 'JanVanDeSandt 10/7/2012 15:13'!
google: aConsumerData

	^ ZnGoogleOAuth2Session new
		consumerData: aConsumerData ;
		yourself! !

!ZnOAuth2Session methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 14:04'!
accessToken
	^ accessToken! !

!ZnOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 15:32'!
authenticationUrl
	"Answer a URL to the login page of the Identity Provider"
	
	self subclassResponsibility 
	! !

!ZnOAuth2Session methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 14:04'!
consumerData
	^ consumerData! !

!ZnOAuth2Session methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 14:04'!
consumerData: anObject
	consumerData := anObject! !

!ZnOAuth2Session methodsFor: 'private' stamp: 'JanVanDeSandt 10/7/2012 14:17'!
fieldDictionaryFrom: aString

	| dict stream |
	
	dict := Dictionary new.
	stream := aString readStream.
	[ stream atEnd ] whileFalse: [ dict at: (stream upTo: $=) put: (stream upTo: $&) ].

	^dict! !

!ZnOAuth2Session methodsFor: 'public' stamp: 'JanVanDeSandt 10/7/2012 15:33'!
handleAuthenticationCallback: request 

	self subclassResponsibility ! !

!ZnOAuth2Session methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 14:04'!
redirectUri
	^ redirectUri! !

!ZnOAuth2Session methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 14:04'!
redirectUri: anObject
	redirectUri := anObject! !

ZnDefaultServerDelegate subclass: #ZnSSOServerDelegate
	instanceVariableNames: 'facebookData googleData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-OAuth2-Core'!

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:32'!
facebookData
	^ facebookData! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:32'!
facebookData: anObject
	facebookData := anObject! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'JanVanDeSandt 12/7/2012 11:23'!
facebookSessionFor: aRequest

	^ aRequest session attributeAt: 'facebook-session'  ifAbsent: [
		aRequest session attributeAt: 'facebook-session' put: ( 
		(ZnOAuth2Session facebook: self facebookData)
			redirectUri: 'http://localhost:8100/sso-facebook-callback' ;
			yourself )]
! !

!ZnSSOServerDelegate methodsFor: 'private' stamp: 'JanVanDeSandt 12/7/2012 11:14'!
generateInvalidCallbackRequest

	| html entity |

	html := String streamContents: [ :stream |
		stream
			nextPutAll: '<h3>Not a valid callback request</h3>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:32'!
googleData
	^ googleData! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:32'!
googleData: anObject
	googleData := anObject! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'JanVanDeSandt 12/7/2012 11:27'!
googleSessionFor: aRequest

	^ aRequest session attributeAt: 'google-session'  ifAbsent: [
		aRequest session attributeAt: 'google-session' put: ( 
			(ZnOAuth2Session google: self googleData)
				redirectUri: 'http://localhost:8100/sso-google-callback' ;
				yourself )]
! !

!ZnSSOServerDelegate methodsFor: 'initialize-release' stamp: 'JanVanDeSandt 10/7/2012 15:14'!
initialize

	super initialize.
	
	self prefixMap
		at: 'sso-google' put: #ssoGoogle: ;
		at: 'sso-google-callback' put: #ssoGoogleCallback: ;
		at: 'sso-facebook' put: #ssoFacebook: ;
		at: 'sso-facebook-callback' put: #ssoFacebookCallback: 
! !

!ZnSSOServerDelegate methodsFor: 'testing' stamp: 'JanVanDeSandt 12/7/2012 11:10'!
isOAuth2Callback: aRequest

	^aRequest uri queryKeys includes: 'code'! !

!ZnSSOServerDelegate methodsFor: 'private' stamp: 'JanVanDeSandt 10/7/2012 14:38'!
printDictionary: aDictionary asHtmlOn: aStream

	aStream
		nextPutAll: '<ul>'.
	aDictionary keysAndValuesDo: [ :key :value |
		aStream
			nextPutAll: '<li>' ;
			nextPutAll: key.
		value isDictionary
			ifTrue: [ self printDictionary: value asHtmlOn: aStream ]
			ifFalse: [
				aStream
					nextPutAll: ' --> ' ;
					nextPutAll: value asString ].
		aStream nextPutAll: '</li>' ].
	aStream nextPutAll: '</ul>'! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 12/7/2012 11:24'!
ssoFacebook: request

	| facebookSession html entity |

	facebookSession := self facebookSessionFor: request.
		
	html := String streamContents: [ :stream |
		stream
			nextPutAll: '<h3>Facebook SSO</h3>' ;
			nextPutAll: '<a href="' ;
			nextPutAll: facebookSession authenticationUrl asString ;
			nextPutAll: '">Login with Facebook</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 12/7/2012 11:25'!
ssoFacebookCallback: request

	| facebookSession userData html entity |
	
	(self isOAuth2Callback: request)
		ifFalse: [ ^ self generateInvalidCallbackRequest ].
	
	facebookSession := self facebookSessionFor: request.
	facebookSession handleAuthenticationCallback: request.
	userData := facebookSession getUserData.

	html := String streamContents: [ :stream |
		stream
			nextPutAll: '<h3>Facebook UserData</h3>'.
		self printDictionary: userData asHtmlOn: stream ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 12/7/2012 11:53'!
ssoGoogle: request

	| oauthSession html entity |
	
	oauthSession := (ZnOAuth2Session google: self googleData)
		redirectUri: 'http://localhost:8100/sso-google-callback' ;
		yourself.
		
	html := String streamContents: [ :stream |
		stream
			nextPutAll: '<h3>Google SSO</h3>' ;
			nextPutAll: '<a href="' ;
			nextPutAll: oauthSession authenticationUrl asString ;
			nextPutAll: '">Login with Google</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 12/7/2012 11:54'!
ssoGoogleCallback: request

	| oauthSession userData html entity |
	
	(self isOAuth2Callback: request)
		ifFalse: [ ^ self generateInvalidCallbackRequest ].

	oauthSession := self googleSessionFor: request.
	oauthSession handleAuthenticationCallback: request.
	userData := oauthSession getUserData.

	html := String streamContents: [ :stream |
		stream
			nextPutAll: '<h3>Google UserData</h3>'.
		self printDictionary: userData asHtmlOn: stream ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !
